#----------
# Scenario:
#----------
#    1. A WCF Service (IService1) has a method called GetToken() which returns a string token.
#
#			public string GetToken()  {  returns "A string token"; }
#				  
#     2. Another WCF Service (IService2) has methods which expects a token as one of the parameters to its method.
#
#           public bool DoSomething(string token, int someValue)  
#           { 
#                // DO something
#                 return true;
#           }
#
#     Test Case : Invoke service1.GetToken() and then invoke service2.DoSomething() passing to it the token
#-------------------------------------------------------------------------------------------------------------------------

import sys
import clr
clr.AddReference("System.XML.dll")

import System.Xml
import System.Diagnostics

from System.Diagnostics import Stopwatch
from System.Xml import XmlDocument

class MySvc:

  def __init__(self, url, contractName):
     self.url = url
     self.contractName = contractName
  def InvokeMethod(self, methodName, xmlInput):
     xmlResp = task.InvokeMethod(self.url, self.contractName , methodName, xmlInput)
     return xmlResp
	 
class MyTestWorkFlow:
  """this is the documentation for the test workflow"""

  xmlInputGetToken = "\
  <GetData>\
    <MethodParameters>\
      <value>0</value>\
      <test isNull='false' />\
    </MethodParameters>\
  </GetData>"
  
  method1Avg = 0.0  
  
  def TimedExecute(self, svc, methodName, xmlInput):
    timer = Stopwatch.StartNew()
    response= svc.InvokeMethod(methodName, xmlInput)
    timer.Stop()
    return timer.Elapsed.TotalSeconds, response
    
 
  def Run(self, counter):
    svc1 = MySvc("http://localhost:52109/Service1.svc", "IPatientManager")
    doc = XmlDocument()
    doc.LoadXml(self.xmlInputGetToken)
    doc.SelectSingleNode("//value").InnerText = counter.ToString()
   
    elapsed,response = self.TimedExecute(svc1, "GetData", doc.OuterXml)
    self.method1Avg = (elapsed + (self.method1Avg * counter))/(counter)


#--------------------------

testTimer = Stopwatch.StartNew()
test = MyTestWorkFlow()
for i in range(1,1000):
  if i % 100 == 0:
    print "\nRunning Average : " + test.method1Avg.ToString() + " sec"
  else:   
    print ".",
  test.Run(i) 
testTimer.Stop()
print "\n----------\nFinal average : " + test.method1Avg.ToString()  
print "Test completed in " + testTimer.Elapsed.TotalSeconds.ToString() + " sec"  